//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * タヌー小ダメージ状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Enemy/Tanue/TanueSmallDamageState.h"
#include "Game/Sound/SoundSystem.h"
#include "Enemy/System/Enemy.h"

#include "Enemy/Tanue/TanueRunState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
TanueSmallDamageState::TanueSmallDamageState(Tanue* tanue) :
	TanueState(tanue){
}
//------------------------------------------------------------------------------
// デストラクタ
TanueSmallDamageState::~TanueSmallDamageState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void TanueSmallDamageState::initialize(){
	// 向きの設定
	Vector3 direction = -getDamageDirection();
	direction.y = 0.f;
	setDirection(direction);
	clearDamage();
	// アニメーションシーケンス設定
	getAnimation()->setSequence(4);
	// 向きと速度の初期化
	setVelocity(getDirection() * -1.f);
	// 無敵カウンタ設定
	setMatchlessCounter(10);
	// 音を鳴らす
	getSoundSystem()->play("TanueSmallDamage");
}
//------------------------------------------------------------------------------
// 後始末
void TanueSmallDamageState::finalize(){
}
//------------------------------------------------------------------------------
// 実行
void TanueSmallDamageState::run(){
	// 定数
	float animationScale = 1.f;

	// ステート変更
	if(getRunCounter() == 30){
		getEnemy()->setState(new TanueRunState(getTanue()));
	}

	// 位置と速度の計算
	calcVelocityAndPosition(getDirection() * -0.3f);

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);

}
//------------------------------------------------------------------------------
